/**************************************
* Configuration details for programs  *
*                                     *
*  fixedoverlapbest, fixedoverlapunam *
*  greatcirclebest,greatcircleunam    *
*  polarbest and polarunam            *
*                                     *
**************************************/



/**************************************
* define LATEX if you want to include *
* your results as a table in a LATEX  *
* document. The file with your        *
* results will contain all the LATEX  *
* punctuation and control symbols     *
* needed, You can paste it directly   *
* into your document without any      *
* further changes.                    *
*                                     *
* To define LATEX, just remove the    *
* two slashes in front of #define.    *
*                                     *
* LATEXDECIMALS is the number of      *
* decimal places that appear in the   *
* table. The number you choose        *
* depends on the size of the table    *
* and on the overall format of the    *
* document - whether one or two       *
* columns per page.                   *
**************************************/

//#define LATEX

#define LATEXDECIMALS  3

/*************************************
* DECIMALS is the number of decimals *
* used in the results if you are NOT *
* using the LATEX format.            *
*************************************/

#define DECIMALS 5

/**************************************
*  Table parameters:                  *
*                                     *
*  These definitions control the      *
*  dimensions of your table.          *
*                                     *
*  The number of ROWS is determined   *
*  by the interval between successive *
*  values of eta. As eta ranges       *
*  between 0 and 1, an interval of    *
*  of 0.25 gives a table of 5 rows,   *
*  and an interval of 0.1 generates   *
*  a table with 11 rows.              *
*                                     *
*  Set ETAINTERVAL to the required    *
*  step size, which must be a sub-    *
*  multiple of 1,                     *
*                                     *
*  The number of COLUMNS is fixed by  *
*  the interval size of beta in the   *
*  fixed overlap programs, and by     *
*  theta in the polar cap programs.   *
*                                     *
*  Set BETAINTERVAL and               *
*  THETAINTERVAL to appropriate       *
*  sub-multiples of PI                *
*  The round brackets are essential.  *
**************************************/

#define ETAINTERVAL 0.1

#define BETAINTERVAL (PI/6)

#define THETAINTERVAL (PI/6)

/*************************************
*  When you have changed the con-    *
*  figuration, you MUST re-compile   *
*  the programs  !                   *
*************************************/